com.tibbo.aggregate.common.action

## Class ServerAction

- java.lang.Object
- - com.tibbo.aggregate.common.action.SequentialAction<I,C,R>
  - - com.tibbo.aggregate.common.action.SingleThreadAction<ServerActionInput,GenericActionCommand,GenericActionResponse>
    - - com.tibbo.aggregate.common.action.ServerAction

- All Implemented Interfaces:
    Action<ServerActionInput,GenericActionCommand,GenericActionResponse>

      public abstract class ServerAction
      extends SingleThreadAction<ServerActionInput,GenericActionCommand,GenericActionResponse>

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ServerAction()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ActionResult` | `call(ServerContext devicesContext, ActionDefinition def, ServerActionInput serverActionInput)`
    `protected abstract ActionResult` | `execute(ServerActionInput parameters)`
    `protected boolean` | `executeDefaultSubstitutors(ServerActionInput parameters)`
    `protected void` | `executeInteractively(java.lang.String operationName, ServerContext ctx, java.util.List<Context> contexts, java.lang.String action, DataTable executionParameters)`
    `protected ServerActionContext` | `getActionContext()`
    `protected ActionDefinition` | `getActionDefinition()`
    `CallerController` | `getCallerController()`
    `ServerContext` | `getDefiningContext()`
    `DataTable` | `getParameter(ServerActionInput input, java.lang.String name)`
    `ServerActionCommandProcessor` | `getProcessor()`
    `ActionResult` | `invoke(ServerActionInput parameters)` Override this method to provide action functionality.
    `protected void` | `processError(java.lang.Throwable ex)`
    `ActionResult` | `redirect(ServerContext ctx, ActionDefinition def, ServerActionInput input)`
    `ActionResult` | `redirect(ServerContext ctx, java.lang.String action, ServerActionInput input)`
    `void` | `redirectToGroupedAction(ServerContext ctx, java.util.List<Context> contexts, java.lang.String action, CallerController caller, DataTable executionParameters)`
    `GenericActionResponse` | `send(GenericActionCommand actionCommand)` Action Implementations should override this method to provide command sending functionality to client.

    - ### Methods inherited from class com.tibbo.aggregate.common.action.SingleThreadAction

      `destroy, init, redirect, redirectById, service, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ServerAction

          public ServerAction()

  - ### Method Detail

    - #### send

          public GenericActionResponse send(GenericActionCommand actionCommand)
                                     throws DisconnectionException

      Description copied from class: `SequentialAction`
      Action Implementations should override this method to provide command sending functionality to client.
      Overrides:
        `send` in class `SingleThreadAction<ServerActionInput,GenericActionCommand,GenericActionResponse>`
      Throws:
        `DisconnectionException`

    - #### getProcessor

          public ServerActionCommandProcessor getProcessor()

    - #### getActionContext

          protected ServerActionContext getActionContext()

      Overrides:
        `getActionContext` in class `SingleThreadAction<ServerActionInput,GenericActionCommand,GenericActionResponse>`

    - #### getActionDefinition

          protected ActionDefinition getActionDefinition()

    - #### getDefiningContext

          public ServerContext getDefiningContext()

    - #### getParameter

          public DataTable getParameter(ServerActionInput input,
                                        java.lang.String name)

    - #### getCallerController

          public CallerController getCallerController()

    - #### invoke

          public ActionResult invoke(ServerActionInput parameters)
                              throws ContextException

      Description copied from class: `SequentialAction`
      Override this method to provide action functionality.
      Specified by:
        `invoke` in class `SequentialAction<ServerActionInput,GenericActionCommand,GenericActionResponse>`
      Throws:
        `ContextException`

    - #### execute

          protected abstract ActionResult execute(ServerActionInput parameters)
                                           throws ContextException

      Throws:
        `ContextException`

    - #### executeDefaultSubstitutors

          protected boolean executeDefaultSubstitutors(ServerActionInput parameters)
                                                throws ContextException

      Throws:
        `ContextException`

    - #### redirect

          public ActionResult redirect(ServerContext ctx,
                                       java.lang.String action,
                                       ServerActionInput input)
                                throws ContextException

      Throws:
        `ContextException`

    - #### redirect

          public ActionResult redirect(ServerContext ctx,
                                       ActionDefinition def,
                                       ServerActionInput input)
                                throws ContextException

      Throws:
        `ContextException`

    - #### call

          public ActionResult call(ServerContext devicesContext,
                                   ActionDefinition def,
                                   ServerActionInput serverActionInput)

    - #### redirectToGroupedAction

          public void redirectToGroupedAction(ServerContext ctx,
                                              java.util.List<Context> contexts,
                                              java.lang.String action,
                                              CallerController caller,
                                              DataTable executionParameters)
                                       throws ContextException,
                                              DisconnectionException

      Throws:
        `ContextException`
        `DisconnectionException`

    - #### executeInteractively

          protected void executeInteractively(java.lang.String operationName,
                                              ServerContext ctx,
                                              java.util.List<Context> contexts,
                                              java.lang.String action,
                                              DataTable executionParameters)
                                       throws ContextException,
                                              DisconnectionException

      Throws:
        `ContextException`
        `DisconnectionException`

    - #### processError

          protected void processError(java.lang.Throwable ex)

      Overrides:
        `processError` in class `SingleThreadAction<ServerActionInput,GenericActionCommand,GenericActionResponse>`